package adminkindboxreqhandler

import (
	echo "github.com/labstack/echo/v4"
)

func (h Handler) SetRoutes(e *echo.Echo) {
	r := e.Group("/admin/kindboxreqs")

	r.POST("/", h.Add).Name = "admin-addkindboxreq"
	r.GET("/:id", h.Get).Name = "admin-getkindboxreqbyid"
	r.GET("/", h.GetAll).Name = "admin-getallkindboxreq"
	r.PATCH("/:id", h.Update).Name = "admin-updatekindboxreq"
}
