package benefactorkindboxreqhandler

import (
	echo "github.com/labstack/echo/v4"
)

func (h Handler) SetRoutes(e *echo.Echo) {
	r := e.Group("/benefactor/kindboxreqs")

	r.POST("/", h.Add).Name = "benefactor-addkindboxreq"
	r.GET("/:id", h.Get).Name = "benefactor-get-kindboxreqbyid"
	r.GET("/", h.GetAll).Name = "benefactor-getallkindboxreq"
	r.PATCH("/:id", h.Update).Name = "benefactor-updatekindboxreq"
}
